#ifndef MOO_ENUM_H
#define MOO_ENUM_H

#define M_DECLARE_ENUM(Name,RealEnum)                   \
class Name {                                            \
private:                                                \
    RealEnum m_value;                                   \
                                                        \
public:                                                 \
    Name(RealEnum v) : m_value(v)                       \
    {                                                   \
    }                                                   \
                                                        \
    RealEnum value() const                              \
    {                                                   \
        return m_value;                                 \
    }                                                   \
                                                        \
    bool operator == (const Name &other) const          \
    {                                                   \
        return m_value == other.m_value;                \
    }                                                   \
                                                        \
    bool operator != (const Name &other) const          \
    {                                                   \
        return m_value != other.m_value;                \
    }                                                   \
                                                        \
};

#endif // MOO_ENUM_H
